#include "Python.h"

int mytype_setattro(PyObject *self, PyObject *name, PyObject *value) {
  printf("Hello from mytype_setattro!\n");
  return PyObject_GenericSetAttr(self, name, value);
}

static PyType_Slot MyType_slots[] = {
  {Py_tp_setattro, mytype_setattro},
  {0, 0},
};

static PyType_Spec MyType_spec = {
  "MyType",
  0,
  0,
  Py_TPFLAGS_DEFAULT,
  MyType_slots,
};

static int
demo_modexec(PyObject *m) {
  PyObject *mytype = PyType_FromSpec(&MyType_spec);
  if (mytype == NULL) goto fail;
  PyModule_AddObject(m, "MyType", mytype);
  return 0;

fail:
  Py_XDECREF(m);
  return -1;
}

static PyModuleDef_Slot demo_slots[] = {
    {Py_mod_exec, demo_modexec},
    {0, NULL}
};

static struct PyModuleDef demo_module = {
    PyModuleDef_HEAD_INIT,
    "demo",
    NULL,
    0,
    NULL,
    demo_slots,
    NULL,
    NULL,
    NULL
};

PyMODINIT_FUNC
PyInit_demo(void)
{
    return PyModuleDef_Init(&demo_module);
}
